/*
 * Tweaked the default autocomplete with a 'startsWith' search function
 */

$(function() {
	fillAutocompletePostalCodes('#postalCode', '#town', postalCodes, 2, 15);
});

String.prototype.startsWith = function(str){
	return (this.indexOf(str) == 0);
}

function fillAutocompletePostalCodes(fieldPostalCode, fieldTown, arrayPostalCodes, minimumLength, maxAmountToShow) {
	$(fieldPostalCode).autocomplete({
	    minLength: minimumLength,
		source: function(request, response) {
			var count = 0;
			var filteredArray = $.map(arrayPostalCodes, function(item) {
				if( count < maxAmountToShow && item.value.startsWith(request.term)){
					count++;
					return item;
				}
				else{
					return null;
				}
			});
			response(filteredArray);
		},
		focus: function(event, ui) {
			$(fieldPostalCode).val(ui.item.value);
			return false;
		},
		select: function(event, ui) {
			$(fieldPostalCode).val(ui.item.value);
			$(fieldTown).val(ui.item.town);
			return false;
		}
	})
	.data( "autocomplete" )._renderItem = function( ul, item ) {
		return $( "<li></li>" )
		.data( "item.autocomplete", item )
		.append( "<a>" + item.value + ' ' + item.town + "</a>" )
		.appendTo( ul );
	};
}